rm(list=ls())
library(rgdal)
library(googleway)
library(imager)
setwd("xxx") # insert your working directory
puntiTemp<-readOGR(dsn=getwd(),layer="puntiFinLatLon") # 'puntiFinLatLon' is the final dataset of the grass procedure
puntisub<-puntiTemp[!duplicated(paste(puntiTemp@coords[,1],puntiTemp@coords[,2])),] 

key <- "yyy" # inster your Google API key
library(imager)

puntisub$sxfov<-atan((puntisub$Hsin-2.5)/puntisub$distS)*180/pi+atan(2.5/puntisub$distS)*180/pi
puntisub$sxfov[is.na(puntisub$sxfov)]<-30+atan(2.5/puntisub$distS)*180/pi
puntisub$sxfov[(puntisub$sxfov)>120]<-60+atan(2.5/puntisub$distS)*180/pi
puntisub$sxpitch<-puntisub$sxfov/2

puntisub$dxfov<-2*atan((puntisub$hdes-4)/puntisub$distD)*180/pi+atan(2.5/puntisub$distD)*180/pi
puntisub$dxfov[is.na(puntisub$dxfov)]<-30+atan(2.5/puntisub$distD)*180/pi
puntisub$dxfov[(puntisub$dxfov)>120]<-60+atan(2.5/puntisub$distD)*180/pi
puntisub$dxpitch<-puntisub$dxfov/2

i<-1
for (i in 1:length(puntisub) {
nome<-paste("xxx",i,"_SxA_",gsub(" ","",puntisub$name[i]),".png",sep="") # insert your working directory
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = c(puntisub$y[i],puntisub$x[i]),size = c(400,400),panorama_id = NULL,output = "plot",heading = as.numeric(puntisub$angolo[i]>=270)*(puntisub$angolo[i]-270)+as.numeric(puntisub$angolo[i]<270)*(puntisub$angolo[i]+90),fov = puntisub$sxfov[i],pitch = puntisub$sxpitch[i],response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)
temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste("xxx",i,"_SxB_",gsub(" ","",puntisub$name[i]),".png",sep="") # insert your working directory
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = c(puntisub$y[i],puntisub$x[i]),size = c(400,400),panorama_id = NULL,output = "plot",heading = as.numeric(puntisub$angolo[i]>=270)*(puntisub$angolo[i]-270)+as.numeric(puntisub$angolo[i]<270)*(puntisub$angolo[i]+90),fov = (90-puntisub$sxpitch[i]+atan(2.5/puntisub$distS)*180/pi)/puntisub$distS[i])*180/pi),pitch =(90-puntisub$sxpitch[i]+atan(2.5/puntisub$distS)*180/pi)/puntisub$distS[i])*180/pi)/2,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)
temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste("xxx",i,"_DxA_",gsub(" ","",puntisub$name[i]),".png",sep="") # insert your working directory
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = c(puntisub$y[i],puntisub$x[i]),size = c(400,400),panorama_id = NULL,output = "plot",heading = as.numeric(puntisub$angolo[i]<=90)*(puntisub$angolo[i]+270)+as.numeric(puntisub$angolo[i]>90)*(puntisub$angolo[i]-90),fov = puntisub$dxfov[i],pitch = puntisub$sxpitch[i],response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)
temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste("xxx",i,"_DxB_",gsub(" ","",puntisub$name[i]),".png",sep="") # insert your working directory
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = c(puntisub$y[i],puntisub$x[i]),size = c(400,400),panorama_id = NULL,output = "plot",heading = as.numeric(puntisub$angolo[i]<=90)*(puntisub$angolo[i]+270)+as.numeric(puntisub$angolo[i]>90)*(puntisub$angolo[i]-90),fov = (90-puntisub$Dxpitch[i]+atan(2.5/puntisub$distd)*180/pi)/puntisub$distd[i])*180/pi),pitch =(90-puntisub$Dxpitch[i]+atan(2.5/puntisub$distd)*180/pi)/puntisub$distd[i])*180/pi)/2,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)
temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
}
#
# end
#
